Bullet Collision Detection & Physics Library: btMultiBodySphericalJointMotor Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Attributes | List of all members
btMultiBodySphericalJointMotor Class Reference

`#include <btMultiBodySphericalJointMotor.h>`

Inheritance diagram for btMultiBodySphericalJointMotor:
[legend]
Collaboration diagram for btMultiBodySphericalJointMotor:
[legend]

## Public Member Functions
| btMultiBodySphericalJointMotor (btMultiBody *body, int link, btScalar maxMotorImpulse)
| This file was written by Erwin Coumans. More...
virtual | ~btMultiBodySphericalJointMotor ()
virtual void | finalizeMultiDof ()
virtual int | getIslandIdA () const
virtual int | getIslandIdB () const
virtual void | createConstraintRows (btMultiBodyConstraintArray &constraintRows, btMultiBodyJacobianData &data, const btContactSolverInfo &infoGlobal)
virtual void | setVelocityTarget (const btVector3 &velTarget, btScalar kd=1.0)
virtual void | setVelocityTargetMultiDof (const btVector3 &velTarget, const btVector3 &kd=btVector3(1.0, 1.0, 1.0))
virtual void | setPositionTarget (const btQuaternion &posTarget, btScalar kp=1.f)
virtual void | setPositionTargetMultiDof (const btQuaternion &posTarget, const btVector3 &kp=btVector3(1.f, 1.f, 1.f))
virtual void | setErp (btScalar erp)
virtual btScalar | getErp () const
virtual void | setRhsClamp (btScalar rhsClamp)
btScalar | getMaxAppliedImpulseMultiDof (int i) const
void | setMaxAppliedImpulseMultiDof (const btVector3 &maxImp)
btScalar | getDamping (int i) const
void | setDamping (const btVector3 &damping)
virtual void | debugDraw (class btIDebugDraw *drawer)
Public Member Functions inherited from btMultiBodyConstraint
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btMultiBodyConstraint (btMultiBody *bodyA, btMultiBody *bodyB, int linkA, int linkB, int numRows, bool isUnilateral, int type)
virtual | ~btMultiBodyConstraint ()
void | updateJacobianSizes ()
void | allocateJacobiansMultiDof ()
int | getConstraintType () const
virtual void | setFrameInB (const btMatrix3x3 &frameInB)
virtual void | setPivotInB (const btVector3 &pivotInB)
virtual void | finalizeMultiDof ()=0
virtual int | getIslandIdA () const =0
virtual int | getIslandIdB () const =0
virtual void | createConstraintRows (btMultiBodyConstraintArray &constraintRows, btMultiBodyJacobianData &data, const btContactSolverInfo &infoGlobal)=0
int | getNumRows () const
btMultiBody * | getMultiBodyA ()
btMultiBody * | getMultiBodyB ()
int | getLinkA () const
int | getLinkB () const
void | internalSetAppliedImpulse (int dof, btScalar appliedImpulse)
btScalar | getAppliedImpulse (int dof)
btScalar | getPosition (int row) const
void | setPosition (int row, btScalar pos)
bool | isUnilateral () const
btScalar * | jacobianA (int row)
const btScalar * | jacobianA (int row) const
btScalar * | jacobianB (int row)
const btScalar * | jacobianB (int row) const
btScalar | getMaxAppliedImpulse () const
void | setMaxAppliedImpulse (btScalar maxImp)
virtual void | debugDraw (class btIDebugDraw *drawer)=0
virtual void | setGearRatio (btScalar ratio)
virtual void | setGearAuxLink (int gearAuxLink)
virtual void | setRelativePositionTarget (btScalar relPosTarget)
virtual void | setErp (btScalar erp)

## Protected Attributes
btVector3 | m_desiredVelocity
btQuaternion | m_desiredPosition
bool | m_use_multi_dof_params
btVector3 | m_kd
btVector3 | m_kp
btScalar | m_erp
btScalar | m_rhsClamp
btVector3 | m_maxAppliedImpulseMultiDof
btVector3 | m_damping
Protected Attributes inherited from btMultiBodyConstraint
btMultiBody * | m_bodyA
btMultiBody * | m_bodyB
int | m_linkA
int | m_linkB
int | m_type
int | m_numRows
int | m_jacSizeA
int | m_jacSizeBoth
int | m_posOffset
bool | m_isUnilateral
int | m_numDofsFinalized
btScalar | m_maxAppliedImpulse
btAlignedObjectArray< btScalar > | m_data

## Additional Inherited Members
Protected Member Functions inherited from btMultiBodyConstraint
void | applyDeltaVee (btMultiBodyJacobianData &data, btScalar *delta_vee, btScalar impulse, int velocityIndex, int ndof)
btScalar | fillMultiBodyConstraint (btMultiBodySolverConstraint &solverConstraint, btMultiBodyJacobianData &data, btScalar *jacOrgA, btScalar *jacOrgB, const btVector3 &constraintNormalAng, const btVector3 &constraintNormalLin, const btVector3 &posAworld, const btVector3 &posBworld, btScalar posError, const btContactSolverInfo &infoGlobal, btScalar lowerLimit, btScalar upperLimit, bool angConstraint=false, btScalar relaxation=1.f, bool isFriction=false, btScalar desiredVelocity=0, btScalar cfmSlip=0, btScalar damping=1.0)

## Detailed Description

Definition at line 24 of file btMultiBodySphericalJointMotor.h.

## Constructor & Destructor Documentation

## ◆ btMultiBodySphericalJointMotor()

btMultiBodySphericalJointMotor::btMultiBodySphericalJointMotor | ( | btMultiBody * | body,
|  | int | link,
|  | btScalar | maxMotorImpulse
| ) |  |

This file was written by Erwin Coumans.

Definition at line 25 of file btMultiBodySphericalJointMotor.cpp.

## ◆ ~btMultiBodySphericalJointMotor()

btMultiBodySphericalJointMotor::~btMultiBodySphericalJointMotor | ( |  | ) |
| virtual

Definition at line 58 of file btMultiBodySphericalJointMotor.cpp.

## Member Function Documentation

## ◆ createConstraintRows()

void btMultiBodySphericalJointMotor::createConstraintRows | ( | btMultiBodyConstraintArray & | constraintRows,
|  | btMultiBodyJacobianData & | data,
|  | const btContactSolverInfo & | infoGlobal
| ) |  |
| virtual

Implements btMultiBodyConstraint.

Definition at line 98 of file btMultiBodySphericalJointMotor.cpp.

## ◆ debugDraw()

virtual void btMultiBodySphericalJointMotor::debugDraw | ( | class btIDebugDraw * | drawer | ) |
| inlinevirtual

Implements btMultiBodyConstraint.

Definition at line 112 of file btMultiBodySphericalJointMotor.h.

## ◆ finalizeMultiDof()

void btMultiBodySphericalJointMotor::finalizeMultiDof | ( |  | ) |
| virtual

Implements btMultiBodyConstraint.

Definition at line 42 of file btMultiBodySphericalJointMotor.cpp.

## ◆ getDamping()

btScalar btMultiBodySphericalJointMotor::getDamping | ( | int | i | ) | const
| inline

Definition at line 102 of file btMultiBodySphericalJointMotor.h.

## ◆ getErp()

virtual btScalar btMultiBodySphericalJointMotor::getErp | ( |  | ) | const
| inlinevirtual

Definition at line 82 of file btMultiBodySphericalJointMotor.h.

## ◆ getIslandIdA()

int btMultiBodySphericalJointMotor::getIslandIdA | ( |  | ) | const
| virtual

Implements btMultiBodyConstraint.

Definition at line 62 of file btMultiBodySphericalJointMotor.cpp.

## ◆ getIslandIdB()

int btMultiBodySphericalJointMotor::getIslandIdB | ( |  | ) | const
| virtual

Implements btMultiBodyConstraint.

Definition at line 80 of file btMultiBodySphericalJointMotor.cpp.

## ◆ getMaxAppliedImpulseMultiDof()

btScalar btMultiBodySphericalJointMotor::getMaxAppliedImpulseMultiDof | ( | int | i | ) | const
| inline

Definition at line 91 of file btMultiBodySphericalJointMotor.h.

## ◆ setDamping()

void btMultiBodySphericalJointMotor::setDamping | ( | const btVector3 & | damping | ) |
| inline

Definition at line 107 of file btMultiBodySphericalJointMotor.h.

## ◆ setErp()

virtual void btMultiBodySphericalJointMotor::setErp | ( | btScalar | erp | ) |
| inlinevirtual

Reimplemented from btMultiBodyConstraint.

Definition at line 78 of file btMultiBodySphericalJointMotor.h.

## ◆ setMaxAppliedImpulseMultiDof()

void btMultiBodySphericalJointMotor::setMaxAppliedImpulseMultiDof | ( | const btVector3 & | maxImp | ) |
| inline

Definition at line 96 of file btMultiBodySphericalJointMotor.h.

## ◆ setPositionTarget()

virtual void btMultiBodySphericalJointMotor::setPositionTarget | ( | const btQuaternion & | posTarget,
|  | btScalar | kp = `1.f`
| ) |  |
| inlinevirtual

Definition at line 64 of file btMultiBodySphericalJointMotor.h.

## ◆ setPositionTargetMultiDof()

virtual void btMultiBodySphericalJointMotor::setPositionTargetMultiDof | ( | const btQuaternion & | posTarget,
|  | const btVector3 & | kp = `btVector3(1.f, 1.f, 1.f)`
| ) |  |
| inlinevirtual

Definition at line 71 of file btMultiBodySphericalJointMotor.h.

## ◆ setRhsClamp()

virtual void btMultiBodySphericalJointMotor::setRhsClamp | ( | btScalar | rhsClamp | ) |
| inlinevirtual

Definition at line 86 of file btMultiBodySphericalJointMotor.h.

## ◆ setVelocityTarget()

virtual void btMultiBodySphericalJointMotor::setVelocityTarget | ( | const btVector3 & | velTarget,
|  | btScalar | kd = `1.0`
| ) |  |
| inlinevirtual

Definition at line 50 of file btMultiBodySphericalJointMotor.h.

## ◆ setVelocityTargetMultiDof()

virtual void btMultiBodySphericalJointMotor::setVelocityTargetMultiDof | ( | const btVector3 & | velTarget,
|  | const btVector3 & | kd = `btVector3(1.0, 1.0, 1.0)`
| ) |  |
| inlinevirtual

Definition at line 57 of file btMultiBodySphericalJointMotor.h.

## Member Data Documentation

## ◆ m_damping

btVector3 btMultiBodySphericalJointMotor::m_damping
| protected

Definition at line 35 of file btMultiBodySphericalJointMotor.h.

## ◆ m_desiredPosition

btQuaternion btMultiBodySphericalJointMotor::m_desiredPosition
| protected

Definition at line 28 of file btMultiBodySphericalJointMotor.h.

## ◆ m_desiredVelocity

btVector3 btMultiBodySphericalJointMotor::m_desiredVelocity
| protected

Definition at line 27 of file btMultiBodySphericalJointMotor.h.

## ◆ m_erp

btScalar btMultiBodySphericalJointMotor::m_erp
| protected

Definition at line 32 of file btMultiBodySphericalJointMotor.h.

## ◆ m_kd

btVector3 btMultiBodySphericalJointMotor::m_kd
| protected

Definition at line 30 of file btMultiBodySphericalJointMotor.h.

## ◆ m_kp

btVector3 btMultiBodySphericalJointMotor::m_kp
| protected

Definition at line 31 of file btMultiBodySphericalJointMotor.h.

## ◆ m_maxAppliedImpulseMultiDof

btVector3 btMultiBodySphericalJointMotor::m_maxAppliedImpulseMultiDof
| protected

Definition at line 34 of file btMultiBodySphericalJointMotor.h.

## ◆ m_rhsClamp

btScalar btMultiBodySphericalJointMotor::m_rhsClamp
| protected

Definition at line 33 of file btMultiBodySphericalJointMotor.h.

## ◆ m_use_multi_dof_params

bool btMultiBodySphericalJointMotor::m_use_multi_dof_params
| protected

Definition at line 29 of file btMultiBodySphericalJointMotor.h.

The documentation for this class was generated from the following files:

- btMultiBodySphericalJointMotor.h
- btMultiBodySphericalJointMotor.cpp